<template>
  <div class="treeMap">
    <div id="echarts-default-chart"></div>
  </div>
</template>

<script setup lang="ts">
import { onMounted, watchEffect,ref, onBeforeUnmount } from 'vue';
import * as echarts from 'echarts';
import { useDataStore } from '@/stores/data';
import {  toTitleCase } from '@/chartPrep';

const store = useDataStore();

const props = defineProps<{
  root: string;
  title: string;
  measurement: string;
  treeMapData: any;
}>();

let myChart: echarts.ECharts | null = null;
const chartId = 'echarts-default-chart';

const isMounted = ref(false);

function loadDataAndRenderChart() {
  if (store.isObserved(props.measurement)) {
    try {
      if (!myChart) {
        let chartDom = document.getElementById(chartId) as HTMLElement;

        if (!chartDom) {
           chartDom = document.getElementById(chartId) as HTMLElement;
        }

        if (!chartDom) {
          console.error('Could not find chart container');
          return;
        }
        myChart = echarts.init(chartDom);

      }

      myChart.setOption({
        tooltip: {
          formatter(info: any) {
            const value = info.value;
            return [
              '<div class="tooltip-title">' +
              '</div>',
              toTitleCase(props.measurement) + ': ' + echarts.format.addCommas(value)
            ].join('');
          }
        },
        series: [
          {
            name: props.root,
            type: 'treemap',
            visibleMin: 300,
            label: {
              show: true,
              formatter: '{b}'
            },
            upperLabel: {
              show: true,
              height: 30
            },
            itemStyle: {
              borderColor: '#fff'
            },
            colorMappingBy: 'value', // map color by value
            color: ['#d94e5d', '#ed9e3e', '#eac736', '#a3cbe6', '#7bb6dd', '#50a3ba'],
            roam: false,
            levels: [
              {
                itemStyle: {
                  borderColor: '#777',
                  borderWidth: 0,
                  gapWidth: 1
                },
                upperLabel: {
                  show: false
                }
              },
              {
                itemStyle: {
                  borderColor: '#555',
                  borderWidth: 5,
                  gapWidth: 1
                },
                emphasis: {
                  itemStyle: {
                    borderColor: '#ddd'
                  }
                }
              },
              {
                colorSaturation: [0.35, 0.5],
                itemStyle: {
                  borderWidth: 5,
                  gapWidth: 1,
                  borderColorSaturation: 0.6
                }
              }
            ],
            data: props.treeMapData
          }
        ]
      },
      true,
      true);
    } catch (error) {
      console.error('Error creating chart:', error);
    }
  }
  else {
    console.error('not observed', props.measurement)
  }
}

watchEffect(() => {
   if(isMounted.value) {
    loadDataAndRenderChart();
   }
});

onMounted(() => {
  loadDataAndRenderChart();
  isMounted.value = true;
});

onBeforeUnmount(() => {
  if (myChart) {
    myChart.dispose();
    myChart = null;
    isMounted.value = false;
  }
});


</script>

<style scoped lang="scss">
@import '@/scss/chart.scss';
</style>
